(document:surround "/std/frame")
(document:insert "/std/functions")

;;; Functions

(define (add-disk)
  (woo-catch/message
   (thunk
    (woo-new "/pkg-register")
    (disk-list rows (woo-list-names "/pkg-register")))))

(define (del-disk)
  (woo-catch/message
    (thunk
      (let ((num (disk-list current)))
	(if (>= num 0)
	  (begin (woo-delete "/pkg-register/" 'name (disk-list text))
	         (disk-list remove num)
	         (disk-list current 0)))))))

;;; UI
         
(gridbox columns "10;80;10"
         ;;
         (spacer)
         (label text (bold (_ "Additional disks")))
	 (spacer)

         ;;
         (spacer)
         (label text (_ "If you have any additional CDs or DVDs for this distribution<br>
please insert them one by one and press 'Add' button"))
         (spacer)

         ;;
         (spacer)
         (document:id disk-list (listbox))
         (spacer)
         ;;
         (spacer)
         (hbox align "left"
	       (document:id add-button (button text (_ "Add") (when clicked (add-disk))))
	       (label "")
	       (document:id del-button (button text (_ "Remove") (when clicked (del-disk)))))
         (spacer)
	 )

;;; Logic

(document:root (when loaded
                 (if (string=? (or (getenv "METHOD") "cdrom") "cdrom")
                   (woo-catch/message
                    (thunk (disk-list rows (woo-list-names "/pkg-register"))))
		   (frame:skip))))
